"""
Django settings for CQCICD project.

Generated by 'django-admin startproject' using Django 1.11.4.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""
from __future__ import absolute_import, unicode_literals
from celery.schedules import crontab
from . import django_env
import os
import sys

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
LOGIN_URL = '/backend/login/'

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'cu&wx6earbwvw)$mo@trg3j@@-7)j^jjf9#!ee1p!a2k19ip68'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = django_env()

ALLOWED_HOSTS = ['114.84.40.24', '127.0.0.1', 'cicd.cqaso.cn', 'cn.cqaso.cn']


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'backend',
    'cicd',
    'rest_framework'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'CQCICD.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'CQCICD.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(os.path.sep, 'var/lib/cicd', 'db.sqlite3'),
    }
}

CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.db.DatabaseCache',
        'LOCATION': 'cache_table',
    }
}


# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    # {
    #     'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    # },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Shanghai'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/
# STATIC_ROOT defined a path used by the command 'collectstatic' copy static file to
STATIC_ROOT = '/opt/static/'
# STATIC_URL defined a url of static file
STATIC_URL = '/static/'
STATICFILES_DIRS = (
    os.path.join(BASE_DIR, 'static'),
)

AUTH_USER_MODEL = 'backend.UserProfile'

CELERY_TIMEZONE = 'Asia/Shanghai'
CELERY_ENABLE_UTC = True
CELERY_BROKER_URL = 'redis://:chuangqi123@127.0.0.1:6678/0'
CELERY_RESULT_BACKEND = 'redis://:chuangqi123@127.0.0.1:6678/0'
CELERY_IMPORTS = (
    'cicd.tasks',
)

# for log
LOGBASE = os.path.join('/var', 'log')
LOG_LEVEL = 'DEBUG' if django_env() else 'INFO'

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'simple': {
            'datefmt': '%Y-%m-%d %H:%M:%S',
            'format': '%(asctime)s %(levelname)s %(message)s'
        },
    },
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'simple'
        },
        'file': {
            'level': 'INFO',
            'class': 'logging.FileHandler',
            'formatter': 'simple',
            'filename': os.path.join(LOGBASE, 'cicd', 'access.log')
        },
        'cicd': {
            'level': 'INFO',
            'class': 'logging.FileHandler',
            'formatter': 'simple',
            'filename': os.path.join(LOGBASE, 'cicd', 'cicd.log')
        },

    },
    'loggers': {

        'django': {
            'handlers': ['console'],
            'propagate': True,
        },
        'django.request': {
            'handlers': ['console', 'file'],
            'level': LOG_LEVEL,
            'propagate': False,
        },
        'django.server': {
            'handlers': ['console', 'file'],
            'level': LOG_LEVEL,
            'propagate': False,
        },
        'cqcicd.cicd': {
            'handlers': ['console', 'cicd'],
            'level': LOG_LEVEL,
            'propagate': False,
        }
    }
}


# 指定私钥位置, 可配置为路径, 如: /root/.ssh/id.rsa
PRIVATE_KEY = os.path.join(BASE_DIR, 'id_rsa')

# GITLAB PRIVATE-TOKEN
PRIVATE_TOKEN = '9aPDMvKRJ3hL-PR4719D'

# 定义前端显示多少天的发布历史
DATE_RANGE = 5

# 工作目录, 请确保所选目录有读写权限
TASK_ROOT = '/data/cicd'
# 定义项目存储目录, 可配置为绝对路径或者相对路径, 相对路径时将继承自TASK_ROOT
PROJECT_DIR = 'projects'
# 定义打包存放目录, 可配置为绝对路径或者相对路径
RELEASE_DIR = 'release'
